%option noyywrap
%x INFORM1 INFORM1b INFORM1z
%{
#include <stdio.h>
#define MONTINYEAR 12
#define TEXTLEN 80
int found_form1 =0 ;
char textbuf[TEXTLEN+1] ;
char textbuf2[TEXTLEN+1] ;
%}

BS	[ \t]*
MONTH	{BS}([Jj]an|[Jj]anuary|[Ff]eb|[Ff]ebruary|[Mm]ar|[Mm]arch|[Aa]pr|[Aa]pril|[Mm]ay|[Jj]un|[Jj]une|[Jj]ul|[Jj]uly|[Aa]ug|[Aa]ugust|[Ss]ep|[Ss]eptember|[Oo]ct|[Oo]ctober|[Nn]ov|[Nn]ovember|[Dd]ec|[Dd]ecember)
WEEKDAY	Sun|Mon|Tue|Wed|Thu|Fri|Sat
DAY	{BS}([1-9]|[12][0-9]|3[01])
YEAR	^year{BS}([0-9]{4})
OOA	{BS}(on_or_after|ooa)
OOB	{BS}(on_or_before|oob)
DAYS	week|work|holi
DAYSPEC	{BS}({WEEKDAY}|day|({DAYS})day|non({DAYS})day|new_moon|first_quarter|full_moon|last_quarter)
TEXT	.*
EOL	\n
FORM1	{OOA}{MONTH}{DAY}{OOB}{MONTH}{DAY}{TEXT}{EOL}
FORM2	{DAYSPEC}*{OOA}{MONTH}{DAY}{OOB}{MONTH}{DAY}{TEXT}{EOL}
COMMENT	^{BS}#{TEXT}
%%
<INITIAL>{DAYSPEC}	{
		if( found_form1)
		{
			yylval.tchar=textbuf2 ;
			strncpy(textbuf2,yytext,TEXTLEN) ;
			strcat(textbuf2," nearest") ;
			return DAYSPEC ;
		}
		else
			printf("%s",yytext) ;
	}

<INITIAL,INFORM1>{OOA}	{
		if( found_form1)
		{
			yylval.tchar=textbuf ;
			strncpy(textbuf,yytext,TEXTLEN) ;
			return OOA ;
		}
		else
			printf("%s",yytext) ;
	}

<INFORM1b>{OOB}	{
		return OOB ;
	}

<INFORM1>{DAY}	{
		yylval.tint = atoi(yytext) ;
		BEGIN(INFORM1b) ;
		return DAY ;
	}

<INFORM1b>{DAY}	{
		yylval.tint = atoi(yytext) ;
		BEGIN(INFORM1z) ;
		return DAY ;
	}

<INFORM1,INFORM1b>{MONTH}	{
		int check ;
		for(check = 1 ; check<= MONTINYEAR ; check++)
				/* compare only 2nd and 3rd letter to have this reveal all 4 versions (with upper/lowercase
				initial, full or 3-letter abbreviations). This works as the 2nd+3rd letter of a month are
				unique and sufficient for identification. Note that the BS (blank space) may still be
				in front of yytext[]. */
			if ( strstr(yytext,monStr[check]) || strstr(yytext,MonStr[check]) )
			{
				yylval.tint=check ;
				break ;
			}
		return MONTH ;
	}

<INITIAL>{FORM1} |
<INITIAL>{FORM2} {
				/* note that REJECT will also undo the
				effect of BEGIN(whatever) */
		BEGIN(INFORM1) ;
		found_form1 = 1 ;
		REJECT ;
	}

<INFORM1z>{TEXT}	{
		yylval.tchar= textbuf ;
		strncpy(textbuf,yytext,TEXTLEN) ;
		BEGIN(INITIAL) ;
		found_form1 = 0 ;
		return TEXT ;
	}

{YEAR}	{
		yylval.tint=atoi(yytext+4) ;
		BEGIN(INITIAL) ;
		found_form1 = 0 ;
		return YEAR ;
		/*
		year=atoi(yytext+4) ;
		printf("%s",yytext) ;
		*/
	}

\n {
		BEGIN(INITIAL) ;
		found_form1 = 0 ;
		return EOL ;
	}

<INITIAL>{COMMENT} {
		/*
		yylval.tchar= textbuf ;
		strncpy(textbuf,yytext,TEXTLEN) ;
		BEGIN(INITIAL) ;
		found_form1 = 0 ;
		return TEXT ;
		*/
		BEGIN(INITIAL) ;
		found_form1 = 0 ;
		return EOL ;
	}

%%
